<template>
  <div>
    <div class="all-notes">
      <div class="menu">
        <a
          class="las la-plus plus-button"
          style="font-size:36px"
          title="Add a new note"
          href="#/note/create"
        ></a>
        <router-link
          v-for="n in notes"
          :key="n.NoteId"
          :to="'/notes/' + n.NoteId"
          :class="getClass(n.NoteId)"
        >
          <div class="short-date">
            <div>{{ formatShortDate(n.CreatedDateTime).date }}</div>
            <div>{{ formatShortDate(n.CreatedDateTime).month }}</div>
          </div>
          {{ n.NoteCaption }}</router-link
        >
      </div>

      <!--div class="note-details">
        <div v-if="selectedNote == null || selectedNote == undefined">
          Loading...
        </div>
        <div v-else>
          <h1 class="caption">{{ selectedNote.NoteCaption }}</h1>
          <div style="margin-bottom:10px">
            <span class="date">
              {{ formatDate(selectedNote.CreatedDateTime) }}
            </span>
          </div>
          <div v-html="mdToHtml(selectedNote.NoteText)"></div>
        </div>
      </div-->
    </div>
  </div>
</template>

<script>
import Constants from "../lib/Constants";
import FetchMethods from "../lib/FetchMethods";
import { format } from "date-fns";

export default {
  data() {
    return {
      notes: [],
      selectedNote: null,
    };
  },

  mounted() {
    document.title = "Notes";
    this.fetchData();
  },

  watch: {
    $route: {
      handler: function() {
        this.fetchData();
      },
    },
  },

  methods: {
    formatDate(dt) {
      return format(new Date(dt), "eeee, dd MMM yyyy, h:mm:ss a");
    },

    formatShortDate(dt) {
      let d = new Date(dt);
      return { date: format(d, "dd"), month: format(d, "MMM") };
    },

    mdToHtml(text) {
      var showdown = require("showdown"),
        converter = new showdown.Converter(),
        html = converter.makeHtml(text);
      return html;
    },

    getClass(noteId) {
      return this.selectedNote.NoteId == noteId ? "active-note" : "";
    },

    fetchDataOld() {
      let userId = JSON.parse(localStorage.getItem(Constants.APP_USER)).UserId;
      FetchMethods.get("note/list/" + userId, (res) => {
        this.notes = res.data;

        console.log(this.$route);

        if (this.$route.params.id) {
          this.selectedNote = this.notes.find(
            (e) => e.NoteId == this.$route.params.id
          );
        } else {
          this.selectedNote = res.data[0];
        }
      });
    },

    fetchData() {
      let userId = JSON.parse(localStorage.getItem(Constants.APP_USER)).UserId;
      FetchMethods.get("note/shortlist/" + userId, (res) => {
        this.notes = res.data;

        console.log(this.notes);

        let selectedNoteId;
        if (this.$route.params.id) {
          selectedNoteId = this.$route.params.id;
        } else {
          selectedNoteId = res.data[0].NoteId;
        }

        console.log({ selectedNoteId });

        this.selectedNote = { NoteId: selectedNoteId }; // TEMP HACK
        // FetchMethods.get("note/detail/" + selectedNoteId, (noteRes) => {
        //   this.selectedNote = noteRes.data;
        // });
      });
    },
  },
};
</script>

<style scoped>
.menu {
  padding-top: 20px;
}

.menu > a {
  display: flex;
  align-items: center;
  width: 100%;
  padding: 10px;
  box-sizing: border-box;
}

.menu > a:hover {
  background-color: #ff634790;
  color: #fff;
}

.active-note {
  background-color: #ff634726;
  color: tomato;
}

.plus-button {
  cursor: pointer;
  width: 44px !important;
  height: 44px !important;
  display: flex;
  align-items: center;
  justify-content: center;
  border: 2px solid;
  border-radius: 50%;
  margin: 0 auto;
  margin-bottom: 10px;
}
</style>
